%    This file is part of the psPack simulation package from the
%    doctoral dissertation "A DAE Formulation for Multi-Zone
%    Application to CVCP Engines" by Per Öberg. 
%    The dissertation is available at 
%    http://urn.kb.se/resolve?urn=urn:nbn:se:liu:diva-18120
%
%    Copyright (C) 2013  Per Öberg <per.oberg@liu.se>
%
%    This program is free software; you can redistribute it and/or modify
%    it under the terms of the GNU General Public License as published by
%    the Free Software Foundation; either version 2 of the License, or
%    (at your option) any later version.
%
%    This program is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%
%    You should have received a copy of the GNU General Public License along
%    with this program; if not, write to the Free Software Foundation, Inc.,
%    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

function dxB = psDVibe(CA,xB)

% [dxB] = psDVibe(CA)
% Calculates the derivative of the burned mass fraction 
% with respect to the crank angle according to Vibe. 
%
% This function belongs to the psPack - process simulation program package
% and should not be run on its own.
%   
% psDist/Vibe/Generic/psDVibe.m

global psSimStruct

CA  = mod(CA,4*pi); 
if nargin >=2
    dxB = (psSimStruct.psVibe.eta-xB).*psSimStruct.psVibe.a*(psSimStruct.psVibe.m+1)/(psSimStruct.psVibe.thetaE-psSimStruct.psVibe.thetaS).*((max(CA,(psSimStruct.psVibe.thetaS))-(psSimStruct.psVibe.thetaS))/((psSimStruct.psVibe.thetaE)-(psSimStruct.psVibe.thetaS))).^psSimStruct.psVibe.m;
else
    dxB = psSimStruct.psVibe.eta*(psSimStruct.psVibe.a*(psSimStruct.psVibe.m+1)/((psSimStruct.psVibe.thetaE)-(psSimStruct.psVibe.thetaS))*((max(CA,(psSimStruct.psVibe.thetaS))-(psSimStruct.psVibe.thetaS))/((psSimStruct.psVibe.thetaE)-(psSimStruct.psVibe.thetaS))).^psSimStruct.psVibe.m.*exp(-psSimStruct.psVibe.a*((max(CA,(psSimStruct.psVibe.thetaS))-(psSimStruct.psVibe.thetaS))/((psSimStruct.psVibe.thetaE)-(psSimStruct.psVibe.thetaS))).^(psSimStruct.psVibe.m+1)));
end

